/**
* @file GMHIKernelPartial.cpp
* @author Erik Rodner

*/
#include "GMHIKernelPartial.h"

using namespace NICE;

void GMHIKernelPartial::multiply (const PartialGenericMatrix::SetType & rowSet, const PartialGenericMatrix::SetType & columnSet, NICE::Vector & y, const NICE::Vector & x) const
{
  NICE::VVector A;
  NICE::VVector B;
  // prepare to calculate sum_i x_i K(x,x_i)
  fmk->hik_prepare_alpha_multiplications(x, A, B);

  fmk->hik_kernel_multiply(A, B, x, y);
}

double GMHIKernelPartial::getDiagonalElement( uint i ) const
{
    Vector diag;
    this->getDiagonalElements(diag);
    return diag[i];
};

